commit 600f73b5c4a422f47bae98e3653c0100d5bfd8c8
Author: jklowden <jklowden>
Date:   Fri Jan 16 20:27:55 2009 +0000

    fewer warnings compiling for Win64

diff --git a/ChangeLog b/ChangeLog
index ad031ad..4f8b5c7 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,26 @@
+Fri Jan 16 15:19:20 EST 2009	JK Lowden <jklowden@freetds.org>
+	* include/md4.h include/md5.h
+	* include/replacements.h
+	* include/sqldb.h include/sqlfront.h include/sybdb.h
+	* include/tds.h include/tds_sysdep_private.h
+	* include/tdsstring.h
+	* samples/odbc_rpc.pl
+	* src/dblib/bcp.c src/dblib/dblib.c
+	* src/dblib/dbopen.c src/dblib/dbutil.c
+	* src/dblib/rpc.c src/dblib/xact.c
+	* src/replacements/fakepoll.c src/replacements/readpassphrase.c
+	* src/replacements/vasprintf.c
+	* src/tds/bulk.c src/tds/challenge.c src/tds/config.c
+	* src/tds/convert.c src/tds/getmac.c src/tds/iconv.c
+	* src/tds/log.c src/tds/login.c src/tds/md4.c
+	* src/tds/md5.c src/tds/mem.c src/tds/net.c src/tds/numeric.c
+	* src/tds/query.c src/tds/read.c src/tds/tdsstring.c
+	* src/tds/threadsafe.c src/tds/token.c src/tds/vstrbuild.c
+	* src/tds/write.c 
+	* src/tds/unittests/dynamic1.c src/tds/unittests/flags.c
+	* src/tds/unittests/numeric.c
+	- fewer warnings compiling for Win64
+
 Mon Jan 12 09:15:34 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/apps/bsqldb.c: ask for password if not specified
 
@@ -1180,4 +1203,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2708 2009/01/12 08:15:52 freddy77 Exp $
+$Id: ChangeLog,v 1.2709 2009/01/16 20:27:55 jklowden Exp $
diff --git a/include/md4.h b/include/md4.h
index 57a3f22..7cc636b 100644
--- a/include/md4.h
+++ b/include/md4.h
@@ -1,7 +1,7 @@
 #ifndef MD4_H
 #define MD4_H
 
-/* $Id: md4.h,v 1.7 2007/03/12 13:28:50 freddy77 Exp $ */
+/* $Id: md4.h,v 1.8 2009/01/16 20:27:56 jklowden Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -15,7 +15,7 @@ struct MD4Context
 };
 
 void MD4Init(struct MD4Context *context);
-void MD4Update(struct MD4Context *context, unsigned char const *buf, unsigned len);
+void MD4Update(struct MD4Context *context, unsigned char const *buf, size_t len);
 void MD4Final(struct MD4Context *context, unsigned char *digest);
 void MD4Transform(TDS_UINT buf[4], TDS_UINT const in[16]);
 
diff --git a/include/md5.h b/include/md5.h
index e7b6c35..86efc0d 100644
--- a/include/md5.h
+++ b/include/md5.h
@@ -1,7 +1,7 @@
 #ifndef MD5_H
 #define MD5_H
 
-/* $Id: md5.h,v 1.4 2007/03/12 13:28:50 freddy77 Exp $ */
+/* $Id: md5.h,v 1.5 2009/01/16 20:27:56 jklowden Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -14,8 +14,7 @@ struct MD5Context {
 };
 
 void MD5Init(struct MD5Context *context);
-void MD5Update(struct MD5Context *context, unsigned char const *buf,
-	       unsigned len);
+void MD5Update(struct MD5Context *context, unsigned char const *buf, size_t len);
 void MD5Final(struct MD5Context *context, unsigned char *digest);
 void MD5Transform(TDS_UINT buf[4], TDS_UINT const in[16]);
 
diff --git a/include/replacements.h b/include/replacements.h
index 0756b1a..62ea20c 100644
--- a/include/replacements.h
+++ b/include/replacements.h
@@ -20,7 +20,7 @@
 #ifndef _replacements_h_
 #define _replacements_h_
 
-/* $Id: replacements.h,v 1.19 2009/01/07 02:58:37 jklowden Exp $ */
+/* $Id: replacements.h,v 1.20 2009/01/16 20:27:56 jklowden Exp $ */
 
 #include <stdarg.h>
 #include "tds_sysdep_public.h"
@@ -49,16 +49,18 @@ extern "C"
 #endif
 
 #if !HAVE_POLL
-#include fakepoll.h
+#include <fakepoll.h>
 #define poll(fds, nfds, timeout) fakepoll((fds), (nfds), (timeout))
 #endif /* !HAVE_POLL */
 
-#if defined(HAVE__VSNPRINTF) && !defined(HAVE_VSNPRINTF)
+#if !HAVE_VSNPRINTF
+#if  HAVE__VSNPRINTF
 #undef vsnprintf
 #define vsnprintf _vsnprintf
-#elif !HAVE_VSNPRINTF
+#else
 int vsnprintf(char *ret, size_t max, const char *fmt, va_list ap);
-#endif /* !HAVE_VSNPRINTF */
+#endif /*  HAVE_VSNPRINTF */
+#endif /* !HAVE__VSNPRINTF */
 
 #if !HAVE_ASPRINTF
 int asprintf(char **ret, const char *fmt, ...);
diff --git a/include/sqldb.h b/include/sqldb.h
index aa3f972..3b64b71 100644
--- a/include/sqldb.h
+++ b/include/sqldb.h
@@ -20,14 +20,46 @@
 #ifndef SQLDB_h
 #define SQLDB_h
 
-#include <sybdb.h>
+#include "./sybdb.h"
+
+#define SQLCHAR SYBCHAR
+#define SQLVARCHAR SYBVARCHAR
+#define SQLINTN SYBINTN
+#define SQLINT1 SYBINT1
+#define SQLINT2 SYBINT2
+#define SQLINT4 SYBINT4
+#define SQLINT8 SYBINT8
+#define SQLFLT8 SYBFLT8
+#define SQLDATETIME SYBDATETIME
+#define SQLBIT SYBBIT
+#define SQLTEXT SYBTEXT
+#define SQLIMAGE SYBIMAGE
+#define SQLMONEY4 SYBMONEY4
+#define SQLMONEY SYBMONEY
+#define SQLDATETIM4 SYBDATETIME4
+#define SQLFLT4 SYBREAL
+#define SQLBINARY SYBBINARY
+#define SQLVARBINARY SYBVARBINARY
+#define SQLNUMERIC SYBNUMERIC
+#define SQLDECIMAL SYBDECIMAL
+#define SQLFLTN SYBFLTN
+#define SQLMONEYN SYBMONEYN
+#define SQLDATETIMN SYBDATETIMN
+#define SQLVOID	SYBVOID
+
+#define SMALLDATETIBIND SMALLDATETIMEBIND
+
+#define DBERRHANDLE_PROC EHANDLEFUNC 
+#define DBMSGHANDLE_PROC MHANDLEFUNC 
 
-/* 
- * TODO: add other Microsoft differences here e.g. SQLMONEY for SYBMONEY
- */
 #define dbfreelogin(x) dbloginfree((x))
 
-static const char rcsid_sqldb_h[] = "$Id: sqldb.h,v 1.4 2007/10/24 21:57:32 jklowden Exp $";
+#define dbprocerrhandle(p, h) dberrhandle((h))
+#define dbprocmsghandle(p, h) dbmsghandle((h))
+
+#define dbwinexit()
+
+static const char rcsid_sqldb_h[] = "$Id: sqldb.h,v 1.5 2009/01/16 20:27:56 jklowden Exp $";
 static const void *const no_unused_sqldb_h_warn[] = { rcsid_sqldb_h, no_unused_sqldb_h_warn };
 
 
diff --git a/include/sqlfront.h b/include/sqlfront.h
index 051e14c..cd38c8e 100644
--- a/include/sqlfront.h
+++ b/include/sqlfront.h
@@ -20,9 +20,9 @@
 #ifndef SQLFRONT_h
 #define SQLFRONT_h
 
-#include <sybfront.h>
+#include "./sybfront.h"
 
-static const char rcsid_sqlfront_h[] = "$Id: sqlfront.h,v 1.4 2007/08/02 11:32:57 freddy77 Exp $";
+static const char rcsid_sqlfront_h[] = "$Id: sqlfront.h,v 1.5 2009/01/16 20:27:56 jklowden Exp $";
 static const void *const no_unused_sqlfront_h_warn[] = { rcsid_sqlfront_h, no_unused_sqlfront_h_warn };
 
 typedef DBPROCESS * PDBPROCESS;
diff --git a/include/sybdb.h b/include/sybdb.h
index 8f769de..823002d 100644
--- a/include/sybdb.h
+++ b/include/sybdb.h
@@ -41,7 +41,7 @@ extern "C"
 #define TDS_STATIC_CAST(type, a) ((type)(a))
 #endif
 
-static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.85 2007/12/02 23:01:37 jklowden Exp $";
+static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.86 2009/01/16 20:27:56 jklowden Exp $";
 static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_sybdb_h_warn };
 
 #ifdef FALSE
@@ -182,6 +182,8 @@ enum
 #define SYBREAL	SYBREAL
 	SYBBINARY = 45,		/* 0x2D */
 #define SYBBINARY	SYBBINARY
+	SYBVOID = 31,		/* 0x1F */
+#define SYBVOID	SYBVOID
 	SYBVARBINARY = 37,	/* 0x25 */
 #define SYBVARBINARY	SYBVARBINARY
 	SYBNUMERIC = 108,	/* 0x6C */
@@ -265,6 +267,7 @@ typedef struct
 } DBDATETIME4;
 
 #ifdef MSDBLIB
+#define DBDATETIM4 DBDATETIME4
 #define SQLCHAR SYBCHAR
 #endif
 
@@ -1052,7 +1055,8 @@ RETCODE dbsetlversion (LOGINREC * login, BYTE version);
 #define dbsetlapp(x,y)		dbsetlname((x), (y), DBSETAPP)
 #define DBSETBCP		6
 #define BCP_SETL(x,y)		dbsetlbool((x), (y), DBSETBCP)
-#define DBSETNATLANG		7
+#define DBSETLSECURE(x)		dbsetlbool((x), (1), DBSETBCP)
+#define DBSETNATLANG		7	
 #define DBSETLNATLANG(x,y)	dbsetlname((x), (y), DBSETNATLANG)
 #define dbsetlnatlang(x,y)	dbsetlname((x), (y), DBSETNATLANG)
 #define DBSETNOSHORT		8	/* not implemented */
diff --git a/include/tds.h b/include/tds.h
index bf96853..bf61881 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.309 2008/12/16 15:41:18 freddy77 Exp $ */
+/* $Id: tds.h,v 1.310 2009/01/16 20:27:57 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1375,7 +1375,7 @@ void tds_cursor_deallocated(TDSSOCKET *tds, TDSCURSOR *cursor);
 void tds_release_cursor(TDSSOCKET *tds, TDSCURSOR *cursor);
 void tds_free_bcp_column_data(BCPCOLDATA * coldata);
 
-int tds_put_n(TDSSOCKET * tds, const void *buf, int n);
+int tds_put_n(TDSSOCKET * tds, const void *buf, size_t n);
 int tds_put_string(TDSSOCKET * tds, const char *buf, int len);
 int tds_put_int(TDSSOCKET * tds, TDS_INT i);
 int tds_put_int8(TDSSOCKET * tds, TDS_INT8 i);
@@ -1407,7 +1407,7 @@ TDSLOCALE *tds_get_locale(void);
 int tds_alloc_row(TDSRESULTINFO * res_info);
 int tds_alloc_compute_row(TDSCOMPUTEINFO * res_info);
 BCPCOLDATA * tds_alloc_bcp_column_data(int column_size);
-unsigned char *tds7_crypt_pass(const unsigned char *clear_pass, int len, unsigned char *crypt_pass);
+unsigned char *tds7_crypt_pass(const unsigned char *clear_pass, size_t len, unsigned char *crypt_pass);
 TDSDYNAMIC *tds_lookup_dynamic(TDSSOCKET * tds, const char *id);
 /*@observer@*/ const char *tds_prtype(int token);
 
@@ -1437,7 +1437,7 @@ char *tds_get_homedir(void);
 TDSPARAMINFO *tds_alloc_param_result(TDSPARAMINFO * old_param);
 void tds_free_input_params(TDSDYNAMIC * dyn);
 void tds_free_dynamic(TDSSOCKET * tds, TDSDYNAMIC * dyn);
-TDSSOCKET *tds_realloc_socket(TDSSOCKET * tds, int bufsize);
+TDSSOCKET *tds_realloc_socket(TDSSOCKET * tds, size_t bufsize);
 char *tds_alloc_client_sqlstate(int msgno);
 char *tds_alloc_lookup_sqlstate(TDSSOCKET * tds, int msgno);
 TDSLOGIN *tds_alloc_login(void);
@@ -1558,7 +1558,7 @@ int tdsdump_open(const char *filename);
 #pragma GCC visibility push(hidden)
 #endif
 void tdsdump_close(void);
-void tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, const void *buf, int length);
+void tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, const void *buf, size_t length);
 void tdsdump_col(const TDSCOLUMN *col);
 void tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 
@@ -1592,7 +1592,7 @@ TDS_INT tds_numeric_to_string(const TDS_NUMERIC * numeric, char *s);
 TDS_INT tds_numeric_change_prec_scale(TDS_NUMERIC * numeric, unsigned char new_prec, unsigned char new_scale);
 
 /* getmac.c */
-void tds_getmac(int s, unsigned char mac[6]);
+void tds_getmac(TDS_SYS_SOCKET s, unsigned char mac[6]);
 
 TDSAUTHENTICATION * tds_ntlm_get_auth(TDSSOCKET * tds);
 TDSAUTHENTICATION * tds_gss_get_auth(TDSSOCKET * tds);
@@ -1662,4 +1662,8 @@ int tds_writetext_end(TDSSOCKET *tds);
 #pragma GCC visibility pop
 #endif
 
+#define TDS_PUT_INT(tds,v) tds_put_int((tds), ((TDS_INT)(v)))
+#define TDS_PUT_SMALLINT(tds,v) tds_put_smallint((tds), ((TDS_SMALLINT)(v)))
+#define TDS_PUT_BYTE(tds,v) tds_put_byte((tds), ((unsigned char)(v)))
+
 #endif /* _tds_h_ */
diff --git a/include/tds_sysdep_private.h b/include/tds_sysdep_private.h
index 4b523e0..4089fd4 100644
--- a/include/tds_sysdep_private.h
+++ b/include/tds_sysdep_private.h
@@ -20,7 +20,7 @@
 #ifndef _tds_sysdep_private_h_
 #define _tds_sysdep_private_h_
 
-/* $Id: tds_sysdep_private.h,v 1.26 2008/11/15 09:57:06 freddy77 Exp $ */
+/* $Id: tds_sysdep_private.h,v 1.27 2009/01/16 20:27:57 jklowden Exp $ */
 
 #undef TDS_RCSID
 #if defined(__GNUC__) && __GNUC__ >= 3
@@ -67,7 +67,8 @@ typedef int pid_t;
 #define getpid() _gethostid()
 #endif	/* defined(DOS32X) */
 
-#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__)
+#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(_WIN64)
+#include <winsock2.h>
 #include <windows.h>
 #define READSOCKET(a,b,c)	recv((a), (char *) (b), (c), TDS_NOSIGNAL)
 #define WRITESOCKET(a,b,c)	send((a), (const char *) (b), (c), TDS_NOSIGNAL)
diff --git a/include/tdsstring.h b/include/tdsstring.h
index 63c732c..6e1aadc 100644
--- a/include/tdsstring.h
+++ b/include/tdsstring.h
@@ -20,7 +20,7 @@
 #ifndef _tdsstring_h_
 #define _tdsstring_h_
 
-/* $Id: tdsstring.h,v 1.19 2007/07/01 10:10:52 freddy77 Exp $ */
+/* $Id: tdsstring.h,v 1.20 2009/01/16 20:27:57 jklowden Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -61,13 +61,13 @@ void tds_dstr_free(DSTR * s);
 
 DSTR* tds_dstr_dup(DSTR * s, const DSTR * src);
 DSTR* tds_dstr_copy(DSTR * s, const char *src);
-DSTR* tds_dstr_copyn(DSTR * s, const char *src, unsigned int length);
+DSTR* tds_dstr_copyn(DSTR * s, const char *src, size_t length);
 DSTR* tds_dstr_set(DSTR * s, char *src);
 
 /** limit length of string, MUST be <= current length */
-DSTR* tds_dstr_setlen(DSTR *s, unsigned int length);
+DSTR* tds_dstr_setlen(DSTR *s, size_t length);
 /** allocate space for length char */
-DSTR* tds_dstr_alloc(DSTR *s, unsigned int length);
+DSTR* tds_dstr_alloc(DSTR *s, size_t length);
 
 /** @} */
 
diff --git a/samples/odbc_rpc.pl b/samples/odbc_rpc.pl
index 9e4cf2c..d3771bb 100755
--- a/samples/odbc_rpc.pl
+++ b/samples/odbc_rpc.pl
@@ -1,5 +1,5 @@
 #!/usr/local/bin/perl
-# $Id: odbc_rpc.pl,v 1.9 2008/07/28 20:58:19 jklowden Exp $
+# $Id: odbc_rpc.pl,v 1.10 2009/01/16 20:27:57 jklowden Exp $
 #
 # Contributed by James K. Lowden and is hereby placed in 
 # the public domain.  No rights reserved.  
@@ -72,6 +72,7 @@ my $dbh = DBI->connect($dsn, $user, $pass, {RaiseError => 1, PrintError => 1, Au
 	or die "Unable for connect to $dsn $DBI::errstr";
 
 setup_error_handler($dbh);
+$dbh->{odbc_putdata_start} = 2 ** 31;
 
 # Construct an odbc placeholder list like (?, ?, ?)
 # for any arguments after $ARGV[0]. 
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index 0a84483..105b1ab 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -41,14 +41,14 @@
 #include <io.h>
 #endif
 
-#include "tds.h"
-#include "tdsiconv.h"
-#include "tdsconvert.h"
-#include "replacements.h"
-#include "sybfront.h"
-#include "sybdb.h"
-#include "syberror.h"
-#include "dblib.h"
+#include <tds.h>
+#include <tdsiconv.h>
+#include <tdsconvert.h>
+#include <replacements.h>
+#include <../../include/sybfront.h>
+#include <../../include/sybdb.h>
+#include <../../include/syberror.h>
+#include <dblib.h>
 
 #ifdef DMALLOC
 #include <dmalloc.h>
@@ -61,15 +61,15 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.178 2008/12/16 09:26:02 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.179 2009/01/16 20:27:57 jklowden Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
-#elif defined(WIN32)
+#elif defined(WIN32) || defined(WIN64)
 /* win32 version */
 typedef __int64 offset_type;
-#define fseeko(f,o,w) (_lseeki64(fileno(f),o,w) == -1)
-#define ftello(f) _telli64(fileno(f))
+#define fseeko(f,o,w) (_fseeki64((f),o,w) == -1)
+#define ftello(f) _ftelli64((f))
 #else
 /* use old version */
 #define fseeko(f,o,w) fseek(f,o,w)
@@ -914,7 +914,7 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 					if ((srctype == SYBDATETIME || srctype == SYBDATETIME4)
 					    && (hostcol->datatype == SYBCHAR || hostcol->datatype == SYBVARCHAR)) {
 						tds_datecrack(srctype, src, &when);
-						buflen = tds_strftime((TDS_CHAR *)hostcol->bcp_column_data->data, 256,
+						buflen = (int)tds_strftime((TDS_CHAR *)hostcol->bcp_column_data->data, 256,
 									 bcpdatefmt, &when);
 					} else {
 						/* 
@@ -1160,9 +1160,9 @@ _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_error)
 		 * and set collen to the field's post-iconv size.  
 		 */
 		if (hostcol->term_len > 0) { /* delimited data file */
-			int file_bytes_left, file_len;
+			int file_len;
 			size_t col_bytes_left;
-			offset_type len;
+			offset_type file_bytes_left, len;
 			iconv_t cd;
 
 			len = _bcp_measure_terminated_field(hostfile, hostcol->terminator, hostcol->term_len);
@@ -1172,7 +1172,7 @@ _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_error)
 				dbperror(dbproc, SYBEBCOR, 0);
 				return (FAIL);
 			}
-			collen = len;
+			collen = (int)len;
 			if (collen == 0)
 				data_is_null = 1;
 
@@ -1206,7 +1206,7 @@ _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_error)
 			col_bytes_left = collen;
 			/* TODO make tds_iconv_fread handle terminator directly to avoid fseek in _bcp_measure_terminated_field */
 			file_bytes_left = tds_iconv_fread(cd, hostfile, file_len, hostcol->term_len, coldata, &col_bytes_left);
-			collen -= col_bytes_left;
+			collen -= (int)col_bytes_left;
 
 			/* tdsdump_log(TDS_DBG_FUNC, "collen is %d after tds_iconv_fread()\n", collen); */
 
@@ -1423,7 +1423,7 @@ _bcp_measure_terminated_field(FILE * hostfile, BYTE * terminator, int term_len)
 		return -1;
 	}
 
-	for (sample_size = 1; (bytes_read = fread(sample, sample_size, 1, hostfile)) != 0;) {
+	for (sample_size = 1; (bytes_read = (int)fread(sample, sample_size, 1, hostfile)) != 0;) {
 
 		bytes_read *= sample_size;
 
@@ -1658,8 +1658,8 @@ _bcp_exec_in(DBPROCESS * dbproc, DBINT * rows_copied)
 					if (fread(row_in_error, chunk, 1, hostfile) != 1) {
 						printf("BILL fread failed after fseek\n");
 					}
-					count = fwrite(row_in_error, chunk, 1, errfile);
-					if( count < chunk ) {
+					count = (int)fwrite(row_in_error, chunk, 1, errfile);
+					if( (size_t)count < chunk ) {
 						dbperror(dbproc, SYBEBWEF, errno);
 					}
 					error_row_size -= chunk;
@@ -1778,7 +1778,7 @@ bcp_exec(DBPROCESS * dbproc, DBINT *rows_copied)
  * \sa 	BCP_SETL(), bcp_batch(), bcp_bind(), bcp_colfmt(), bcp_colfmt_ps(), bcp_collen(), bcp_colptr(), bcp_columns(), bcp_control(), bcp_done(), bcp_exec(), bcp_getl(), bcp_init(), bcp_moretext(), bcp_options(), bcp_readfmt(), bcp_sendrow()
  */
 static char *
-_bcp_fgets(char *buffer, size_t size, FILE *f)
+_bcp_fgets(char *buffer, int size, FILE *f)
 {
 	char *p = fgets(buffer, size, f);
 	if (p == NULL) 
@@ -1833,7 +1833,7 @@ bcp_readfmt(DBPROCESS * dbproc, char *filename)
 	}
 
 	if ((_bcp_fgets(buffer, sizeof(buffer), ffile)) != NULL) {
-		lf_version = atof(buffer);
+		lf_version = (float)atof(buffer);
 	} else if (ferror(ffile)) {
 		dbperror(dbproc, SYBEBRFF, errno);
 		return FAIL;
@@ -2366,9 +2366,9 @@ _bcp_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset)
 			data_is_null = 1;
 		else {
 			if (collen)
-				collen = (bindcol->column_bindlen < collen) ? bindcol->column_bindlen : collen;
+				collen = (int) ((bindcol->column_bindlen < (TDS_UINT)collen) ? bindcol->column_bindlen : (TDS_UINT)collen);
 			else
-				collen = bindcol->column_bindlen;
+				collen = (int) bindcol->column_bindlen;
 		}
 	}
 
@@ -2468,7 +2468,7 @@ rtrim(char *str, int len)
 	while (p > str && *p == ' ') {
 		*p-- = '\0';
 	}
-	return 1 + p - str;
+	return (int)(1 + p - str);
 }
 
 /** 
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index ec1d31f..970be28 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -63,20 +63,20 @@
  * 	strucures are defined.  
  */
 #define SYBDBLIB 1
-#include "tds.h"
-#include "tdsthread.h"
-#include "sybfront.h"
-#include "sybdb.h"
-#include "syberror.h"
-#include "dblib.h"
-#include "tdsconvert.h"
-#include "replacements.h"
+#include <tds.h>
+#include <tdsthread.h>
+#include <tdsconvert.h>
+#include <replacements.h>
+#include <../../include/sybfront.h>
+#include <../../include/sybdb.h>
+#include <../../include/syberror.h>
+#include <dblib.h>
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.337 2008/12/17 11:04:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.338 2009/01/16 20:27:57 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -563,7 +563,7 @@ dbgetnull(DBPROCESS *dbproc, int bindtype, int varlen, BYTE* varaddr)
 		memcpy(varaddr, pnullrep->bindval, pnullrep->len);
 		return SUCCEED;
 	default:
-		if (pnullrep->bindval && (varlen <= 0 || varlen >= pnullrep->len)) {
+		if (pnullrep->bindval && (varlen <= 0 || (size_t)varlen >= pnullrep->len)) {
 			memcpy(varaddr, pnullrep->bindval, pnullrep->len);
 		}
 	}
@@ -610,7 +610,7 @@ dbgetnull(DBPROCESS *dbproc, int bindtype, int varlen, BYTE* varaddr)
 	 * BINARYBIND		Empty array (padded with zeros)
 	 */
 	varaddr += pnullrep->len;
-	varlen  -= pnullrep->len;
+	varlen  -= (int)pnullrep->len;
 	if (varlen > 0) {
 		switch (bindtype) {
 		case CHARBIND:
@@ -931,7 +931,7 @@ dbstring_concat(DBSTRING ** dbstrp, const char *p)
 		dbperror(NULL, SYBEMEM, errno);
 		return FAIL;
 	}
-	(*strp)->strtotlen = strlen(p);
+	(*strp)->strtotlen = (DBINT)strlen(p);
 	if (((*strp)->strtext = malloc((*strp)->strtotlen)) == NULL) {
 		TDS_ZERO_FREE(*strp);
 		dbperror(NULL, SYBEMEM, errno);
@@ -1241,9 +1241,6 @@ dbfcmd(DBPROCESS * dbproc, const char *fmt, ...)
 RETCODE
 dbcmd(DBPROCESS * dbproc, const char *cmdstring)
 {
-	int newsz;
-	void *p;
-
 	tdsdump_log(TDS_DBG_FUNC, "dbcmd(%p, %s)\n", dbproc, cmdstring);
 	CHECK_DBPROC();
 	DBPERROR_RETURN(IS_TDSDEAD(dbproc->tds_socket), SYBEDDNE);
@@ -1266,16 +1263,18 @@ dbcmd(DBPROCESS * dbproc, const char *cmdstring)
 			return FAIL;
 		}
 		strcpy((char *) dbproc->dbbuf, cmdstring);
-		dbproc->dbbufsz = strlen(cmdstring) + 1;
+		dbproc->dbbufsz = (int)strlen(cmdstring) + 1;
 	} else {
-		newsz = strlen(cmdstring) + dbproc->dbbufsz;
+		void *p;
+		size_t newsz = strlen(cmdstring) + dbproc->dbbufsz;
+
 		if ((p = realloc(dbproc->dbbuf, newsz)) == NULL) {
 			dbperror(dbproc, SYBEMEM, errno);
 			return FAIL;
 		}
 		dbproc->dbbuf = (unsigned char *) p;
 		strcat((char *) dbproc->dbbuf, cmdstring);
-		dbproc->dbbufsz = newsz;
+		dbproc->dbbufsz = (int)newsz;
 	}
 
 	dbproc->command_state = DBCMDPEND;
@@ -1854,7 +1853,7 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 	case SMALLDATETIMEBIND:
 	case SMALLMONEYBIND:
 	case TINYBIND:
-		bindlen = default_null_representations[bindtype].len;
+		bindlen = (int)default_null_representations[bindtype].len;
 		break;
 
 	case CHARBIND:
@@ -1862,9 +1861,9 @@ dbsetnull(DBPROCESS * dbproc, int bindtype, int bindlen, BYTE *bindval)
 		CHECK_PARAMETER(bindlen >= 0, SYBEBBL, FAIL);
 		break;
 		
-	case NTBSTRINGBIND:	bindlen = strlen((char *) bindval);
+	case NTBSTRINGBIND:	bindlen = (int)strlen((char *) bindval);
 		break;
-	case STRINGBIND:	bindlen = strlen((char *) bindval);
+	case STRINGBIND:	bindlen = (int)strlen((char *) bindval);
 		break;
 	case VARYBINBIND:	bindlen = ((TDS_VARBINARY*) bindval)->len;
 		break;
@@ -2168,7 +2167,7 @@ dbconvert(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT srclen, int d
 
 	/* srclen of -1 means the source data is definitely NULL terminated */
 	if (srclen == -1)
-		srclen = strlen((const char *) src);
+		srclen = (int)strlen((const char *) src);
 
 	/* oft times we are asked to convert a data type to itself */
 	if (srctype == desttype) {
@@ -2195,7 +2194,7 @@ dbconvert(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT srclen, int d
 		case SYBTEXT:
 			/* srclen of -1 means the source data is definitely NULL terminated */
 			if (srclen == -1)
-				srclen = strlen((const char *) src);
+				srclen = (int)strlen((const char *) src);
 
 			switch (destlen) {
 			case  0:	/* nothing to copy */
@@ -2682,7 +2681,7 @@ dbcount(DBPROCESS * dbproc)
 
 	if (!dbproc || !dbproc->tds_socket || dbproc->tds_socket->rows_affected == TDS_NO_COUNT)
 		return -1;
-	return dbproc->tds_socket->rows_affected;
+	return (DBINT)dbproc->tds_socket->rows_affected;
 }
 
 /**
@@ -3188,7 +3187,7 @@ dbspr1row(DBPROCESS * dbproc, char *buffer, DBINT buf_len)
 			if (srctype == SYBDATETIME || srctype == SYBDATETIME4) {
 				memset(&when, 0, sizeof(when));
 				tds_datecrack(srctype, dbdata(dbproc, col + 1), &when);
-				len = tds_strftime(buffer, buf_len, "%b %d %Y %I:%M%p", &when);
+				len = (int)tds_strftime(buffer, buf_len, "%b %d %Y %I:%M%p", &when);
 			} else {
 				len = dbconvert(dbproc, srctype, dbdata(dbproc, col + 1), dbdatlen(dbproc, col + 1), 
 						desttype, (BYTE *) buffer, buf_len);
@@ -3294,7 +3293,7 @@ dbprrow(DBPROCESS * dbproc)
 					if (srctype == SYBDATETIME || srctype == SYBDATETIME4) {
 						memset(&when, 0, sizeof(when));
 						tds_datecrack(srctype, dbdata(dbproc, col + 1), &when);
-						len = tds_strftime(dest, sizeof(dest), STD_DATETIME_FMT, &when);
+						len = (int)tds_strftime(dest, sizeof(dest), STD_DATETIME_FMT, &when);
 					} else {
 						len = dbconvert(dbproc, srctype, dbdata(dbproc, col + 1), dbdatlen(dbproc, col + 1),
 								desttype, (BYTE *) dest, sizeof(dest));
@@ -3425,7 +3424,7 @@ dbprrow(DBPROCESS * dbproc)
 				if (srctype == SYBDATETIME || srctype == SYBDATETIME4) {
 					memset(&when, 0, sizeof(when));
 					tds_datecrack(srctype, dbadata(dbproc, computeid, col), &when);
-					len = tds_strftime(dest, sizeof(dest), STD_DATETIME_FMT, &when);
+					len = (int)tds_strftime(dest, sizeof(dest), STD_DATETIME_FMT, &when);
 				} else {
 					len = dbconvert(dbproc, srctype, dbadata(dbproc, computeid, col), -1, desttype,
 							(BYTE *) dest, sizeof(dest));
@@ -4551,7 +4550,6 @@ dbsqlok(DBPROCESS * dbproc)
 	 * We're looking for a result token or a done token.
          */
 	while (!done) {
-		int retcode;
 		marker = tds_peek(tds);
 
 		/* If we hit a result token, then we know everything is OK.  */
@@ -4732,7 +4730,7 @@ dbbylist(DBPROCESS * dbproc, int computeid, int *size)
 	 * stores these data.
 	 */
 	if (info->by_cols > 0 && info->bycolumns[0] != byte_flag) {
-		unsigned int n;
+		int n;
 		TDS_TINYINT *p = malloc(sizeof(info->bycolumns[0]) + info->by_cols);
 		if (!p) {
 			dbperror(dbproc, SYBEMEM, errno);
@@ -6070,7 +6068,7 @@ dbsafestr(DBPROCESS * dbproc, const char *src, DBINT srclen, char *dest, DBINT d
 		return FAIL;
 
 	if (srclen == -1)
-		srclen = strlen(src);
+		srclen = (int)strlen(src);
 
 	if (quotetype == DBSINGLE || quotetype == DBBOTH)
 		squote = TRUE;
@@ -6908,7 +6906,7 @@ dbiordesc(DBPROCESS * dbproc)
 {
 	tdsdump_log(TDS_DBG_FUNC, "dbiordesc(%p)\n", dbproc);
 	CHECK_PARAMETER(dbproc, SYBENULL, -1);
-	return dbproc->tds_socket->s;
+	return (int)dbproc->tds_socket->s;
 }
 
 
@@ -6925,7 +6923,7 @@ dbiowdesc(DBPROCESS * dbproc)
 	tdsdump_log(TDS_DBG_FUNC, "dbiowdesc(%p)\n", dbproc);
 	CHECK_PARAMETER(dbproc, SYBENULL, -1);
 
-	return dbproc->tds_socket->s;
+	return (int)dbproc->tds_socket->s;
 }
 
 DBBOOL
@@ -7814,7 +7812,7 @@ dbperror (DBPROCESS *dbproc, DBINT msgno, long errnum, ...)
 			assert(*(pformats - 1) == '\0'); 
 			if(*pformats != '\0') {
 				va_list ap;
-				int result_len, len = 2 * strlen(ptext);
+				int result_len, len = 2 * (int)strlen(ptext);
 				char * buffer = calloc(1, len);
 
 				if (buffer == NULL)
diff --git a/src/dblib/dbopen.c b/src/dblib/dbopen.c
index ea70906..34e21ed 100644
--- a/src/dblib/dbopen.c
+++ b/src/dblib/dbopen.c
@@ -21,8 +21,8 @@
 #include <config.h>
 #endif
 
-#include "tds.h"
-#include "sybdb.h"
+#include <tds.h>
+#include <../../include/sybdb.h>
 
 #ifdef DMALLOC
 #include <dmalloc.h>
@@ -32,7 +32,7 @@
 #undef dbopen
 #endif
 
-TDS_RCSID(var, "$Id: dbopen.c,v 1.11 2007/09/20 15:32:54 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dbopen.c,v 1.12 2009/01/16 20:27:58 jklowden Exp $");
 
 DBPROCESS *
 dbopen(LOGINREC * login, const char *server)
diff --git a/src/dblib/dbutil.c b/src/dblib/dbutil.c
index da87bf4..d48bf4b 100644
--- a/src/dblib/dbutil.c
+++ b/src/dblib/dbutil.c
@@ -29,17 +29,16 @@
 #include <stdlib.h>
 #endif /* HAVE_STDLIB_H */
 
-#include "tds.h"
-#include "sybdb.h"
-#include "syberror.h"
-#include "dblib.h"
-/* #include "fortify.h" */
+#include <tds.h>
+#include <../../include/sybdb.h>
+#include <../../include/syberror.h>
+#include <dblib.h>
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dbutil.c,v 1.44 2008/12/03 08:37:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dbutil.c,v 1.45 2009/01/16 20:27:58 jklowden Exp $");
 
 /*
  * test include consistency 
diff --git a/src/dblib/rpc.c b/src/dblib/rpc.c
index 4b26de4..8483f0c 100644
--- a/src/dblib/rpc.c
+++ b/src/dblib/rpc.c
@@ -43,18 +43,18 @@
 
 #include <assert.h>
 
-#include "tds.h"
-#include "tdsconvert.h"
-#include "sybfront.h"
-#include "sybdb.h"
-#include "dblib.h"
-#include "replacements.h"
+#include <tds.h>
+#include <tdsconvert.h>
+#include <replacements.h>
+#include <../../include/sybfront.h>
+#include <../../include/sybdb.h>
+#include <dblib.h>
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: rpc.c,v 1.65 2008/06/12 01:00:48 jklowden Exp $");
+TDS_RCSID(var, "$Id: rpc.c,v 1.66 2009/01/16 20:27:58 jklowden Exp $");
 
 static void rpc_clear(DBREMOTE_PROC * rpc);
 static void param_clear(DBREMOTE_PROC_PARAM * pparam);
@@ -415,7 +415,7 @@ param_info_alloc(TDSSOCKET * tds, DBREMOTE_PROC * rpc)
 		/* meta data */
 		if (p->name) {
 			tds_strlcpy(pcol->column_name, p->name, sizeof(pcol->column_name));
-			pcol->column_namelen = strlen(pcol->column_name);
+			pcol->column_namelen = (int)strlen(pcol->column_name);
 		}
 
 		tds_set_param_type(tds, pcol, temp_type);
diff --git a/src/dblib/xact.c b/src/dblib/xact.c
index 13e505c..6553d68 100644
--- a/src/dblib/xact.c
+++ b/src/dblib/xact.c
@@ -28,16 +28,16 @@
 #include <unistd.h>
 #endif /* HAVE_UNISTD_H */
 
-#include "tds.h"
-#include "sybfront.h"
-#include "sybdb.h"
-#include "dblib.h"
+#include <tds.h>
+#include <../../include/sybfront.h>
+#include <../../include/sybdb.h>
+#include <dblib.h>
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: xact.c,v 1.11 2006/12/26 14:56:19 freddy77 Exp $");
+TDS_RCSID(var, "$Id: xact.c,v 1.12 2009/01/16 20:27:58 jklowden Exp $");
 
 
 void
diff --git a/src/replacements/fakepoll.c b/src/replacements/fakepoll.c
index 3685092..be525d8 100644
--- a/src/replacements/fakepoll.c
+++ b/src/replacements/fakepoll.c
@@ -18,10 +18,10 @@
  * Converted to C and spruced up by James K. Lowden December 2008. 
  */
 
-static char software_version[] = "$Id: fakepoll.c,v 1.5 2009/01/03 14:56:53 freddy77 Exp $";
+static char software_version[] = "$Id: fakepoll.c,v 1.6 2009/01/16 20:27:58 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#include "fakepoll.h"
+#include <replacements.h>
 
 #if HAVE_SYS_TYPES_H
 #include <sys/types.h>
diff --git a/src/replacements/readpassphrase.c b/src/replacements/readpassphrase.c
index 40c4069..666f33a 100644
--- a/src/replacements/readpassphrase.c
+++ b/src/replacements/readpassphrase.c
@@ -73,7 +73,7 @@ static const char rcsid[] = "$OpenBSD: readpassphrase.c,v 1.16 2003/06/17 21:56:
 
 #include <replacements/readpassphrase.h>
 
-#ifndef WIN32
+#if !defined(_WIN32) && !defined(_WIN64)
 #include <termios.h>
 
 #ifndef _PATH_TTY
diff --git a/src/replacements/vasprintf.c b/src/replacements/vasprintf.c
index bdb0df9..7d1ded4 100644
--- a/src/replacements/vasprintf.c
+++ b/src/replacements/vasprintf.c
@@ -30,7 +30,7 @@
 #include "tds_sysdep_private.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: vasprintf.c,v 1.18 2007/12/27 13:45:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: vasprintf.c,v 1.19 2009/01/16 20:27:58 jklowden Exp $");
 
 #if defined(HAVE__VSNPRINTF) && !defined(HAVE_VSNPRINTF)
 #undef HAVE_VSNPRINTF
@@ -48,7 +48,7 @@ int
 vasprintf(char **ret, const char *fmt, va_list ap)
 {
 #if HAVE_VSNPRINTF
-	int chunks;
+	size_t chunks;
 	size_t buflen;
 	char *buf;
 	int len;
@@ -61,7 +61,7 @@ vasprintf(char **ret, const char *fmt, va_list ap)
 			return -1;
 		}
 		len = vsnprintf(buf, buflen, fmt, ap);
-		if (len >= 0 && (size_t) len < (buflen - 1)) {
+		if (0 <= len && (size_t) len < buflen - 1) {
 			break;
 		}
 		free(buf);
@@ -70,7 +70,7 @@ vasprintf(char **ret, const char *fmt, va_list ap)
 		 * len >= 0 are required for vsnprintf implementation that 
 		 * return -1 of buffer insufficient
 		 */
-		if (len >= 0 && (size_t) len >= buflen) {
+		if (buflen <= (size_t) len) {
 			buflen = len + 1;
 		}
 	}
